<script lang="ts">
  import Button from '$lib/components/Button.svelte';
  import TextField from '$lib/components/fields/TextField.svelte';
  import FileField from '$lib/components/fields/FileField.svelte';
  import MarkdownField from '$lib/components/fields/MarkdownField.svelte';
  import { axiosInstance } from '$lib/config/index.js';
  import { PUBLIC_API_URL } from '$env/static/public';
  import FileItem from '$lib/components/Items/FileItem.svelte';

  export let news: any = null;

  let id: number,
    name: string,
    anons: string,
    text: string,
    tags: any[],
    attachment: any,
    attachments: any;

  if (news) {
    id = news.id;
    name = news.name;
    anons = news.anons;
    tags = news.tags;
    text = news.text;

    (async () => {
      if (news.attachments?.length) {
        const attachments = [];
        for (const attachment of news.attachments) {
          const { data, status, headers } = await axiosInstance.get(`/attachment/${attachment.attachmentId}`);
          if (status === 200) {
            const file = new File([data], attachment.attachmentId, { type: headers['content-type'] });
            attachments.push({ file, id: attachment.attachmentId });
          }
        }
        news.attachments = attachments;
      }
    })();
  }

  async function handleSubmit() {
    if (name && anons && text && (attachment || news.attachment)) {
      let attachmentId = null,
        attachmentsId = [];

      try {
        let resAttachment = null;

        if (attachment) {
          resAttachment = await axiosInstance[attachment.id ? 'patch' : 'post'](`/attachment${attachment.id ? `/${attachment.id}` : ''}`, {
            file: attachment[0]
          }, {
            headers: {
              'Content-Type': 'multipart/form-data'
            }
          });
        }

        if (attachments) {
          for (const file of attachments) {
            const {
              data,
              status
            } = await axiosInstance[file.id ? 'patch' : 'post'](`/attachment${file.id ? `/${file.id}` : ''}`, {
              file
            }, {
              headers: {
                'Content-Type': 'multipart/form-data'
              }
            });

            if (status === 201 || status === 200) {
              attachmentsId.push(data.data.id);
            }
          }
        }

        if (resAttachment?.status === 201 || resAttachment?.status === 200 || news.attachment) {
          attachmentId = resAttachment?.data.data.id ?? news.attachmentId;
          const res = await axiosInstance[id ? 'patch' : 'post'](`/news${id ? `/${id}` : ''}`, {
            name,
            anons,
            text,
            attachment: attachmentId,
            ...(attachmentsId.length && { attachmentsId })
          });

          if (res.status === 201) {
            window.location.href = '/admin/news';
          }

          if (res.status === 200) {
            alert('Успешно сохранено.');
          }
        }
      } catch (err: any) {
        console.error(err);

        await axiosInstance.delete(`/attachment/${attachmentId}`);
        for (const id of attachmentsId) {
          await axiosInstance.delete(`/attachment/${id}`);
        }

        switch (err.response.status) {
          case 400:
            alert('Неверные данные');
            break;
          default:
            alert('Возникла ошибка. Попробуйте повторить действие.');
        }
      }
    }
  }

  async function handleAttachmentRemove(event: any) {
    // await axiosInstance.delete(`/attachment/${attachmentId}`);

    news.attachments = news.attachments.filter((attachment: any) => attachment.id !== event.detail.id);
  }
</script>

<form
    method="post"
    on:submit|preventDefault={handleSubmit}
    class="{$$props.class} space-y-6 mx-auto max-w-screen-xl"
>
    <h1 class="text-6xl text-center mb-2 font-serif">
        {#if news}
            Изменение записи
            <p class="text-lg text-neutral-600"><span class="select-none">ID:</span>{id}</p>
        {:else}
            Создание записи
        {/if}
    </h1>

    {#if news}
        <img src="{PUBLIC_API_URL}/attachment/{news.attachmentId}" alt="" class="h-40 rounded">
    {/if}
    <FileField label="Фото" name="attachment" bind:files={attachment}/>
    <TextField label="Наименование" name="name" bind:value={name}/>
    <TextField label="Анонс" name="anons" bind:value={anons}/>
    <!--    <SelectField label="Теги" name="tags" bind:value={tags}/>-->
    <FileField label="Галерея" name="attachments" multiple bind:files={attachments}/>
    {#if news?.attachments}
        {#each news.attachments as { file, id }}
            {#if file instanceof File}
                <FileItem {file} {id} on:remove={handleAttachmentRemove}/>
            {/if}
        {/each}
    {/if}
    <MarkdownField label="Текст" name="text" bind:value={text}/>

    <section class="flex justify-center gap-6">
        <a href="/admin/news">
            <Button transparent>Отменить</Button>
        </a>
        <Button>
            {#if news}
                Сохранить
            {:else}
                Создать
            {/if}
        </Button>
    </section>
</form>